/**************************************************************************************************

Copyright (c) 2007-2015   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "mtk_satellite_data.h"
#include  "mtk_objects.h"
#include  "../common/astro/astrometry.h"
#include  "mtk_gl_common.h"
#include  "mtk_OpenGL.h"
#include  "mtk_mode.h"
#include  "mtk_planet_orientation.h"
#include  "mtk_planet_position.h"
#include  "mtk_lunar_pos.h"
#include  "../common/astro/cele_mech.h"
#include  "mtk_orbital_element.h"
#include  "mtk_solar_system.h"
#include  "mtk_colors.h"
#include  "mtk_label.h"
#include  "mtk_satellites.h"





//------------------
//  Satellite data
//------------------
const satellite_data  sat_data[] = {
//===============
//   Earth (1)
//===============
	{
		"Earth",
		"Moon",			{"Moon", "{|}"},			"moon.jpg",
		1738.4, 1737.5, 1736.7,
		SAT_ORBIT_MOON,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	},

//==============
//   Mars (2)
//==============
	//--  Phobos
	{
		"Mars",
		"Phobos",		{"Phobos", "tH{X"},			"phobos.jpg",
		13.4, 11.2, 9.2,
		SAT_ORBIT_LAPLACE,
		2433282.5, 9380.0, 0.0151, 150.247,  92.474, 1.075, 164.931, 1128.8444155,  0.319,   1.131,  2.262, 317.724, 52.924
	},
	//--  Dimos
	{
		"Mars",
		"Deimos",		{"Deimos", "_CX"},			"deimos.jpg",
		7.5, 6.1, 5.2,
		SAT_ORBIT_LAPLACE,
		2433282.5, 23460.0, 0.0002, 290.496, 296.230, 1.793,  339.6,   285.1618919,  1.262,   26.892, 54.536,  316.700, 53.564
	},

//=================
//   Jupiter (62)
//=================
	//--  Io
	{
		"Jupiter",
		"Io",			{"Io", "CI"},					"io.jpg",
		1830.0, 1818.7, 1815.3,
		SAT_ORBIT_LAPLACE,
		2450464.5, 421800.0, 0.0041,  84.129, 342.021, 0.036,  43.977,  203.4889583,  1.769,   1.625,  7.420, 268.057, 64.495
	},
	//--  Europa
	{
		"Jupiter",
		"Europa",		{"Europa", "GEp"},			"europa.jpg",
		1565.0, 1565.0, 1565.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 671100.0, 0.0094,  88.970, 171.016, 0.466, 219.106,  101.3747242,  3.551,   1.394, 30.184, 268.084, 64.506
	},
	//--  Ganymede
	{
		"Jupiter",
		"Ganymede",		{"Ganymede", "Kjf"},			"ganymede.jpg",
		2634.0, 2634.0, 2634.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 1070400.0, 0.0013, 192.417, 317.540, 0.177,  63.552,   50.3176072,  7.155,  63.549, 132.654, 268.168, 64.543
	},
	//--  Callisto
	{
		"Jupiter",
		"Callisto",		{"Callisto", "JXg"},			"callisto.jpg",
		2403.0, 2403.0, 2403.0,
		SAT_ORBIT_LAPLACE,
		2450464.5,  1882700.0, 0.0074,  52.643, 181.408, 0.192, 298.848,   21.5710728, 16.69,  205.75,  338.82, 268.639, 64.749
	},
	//--  Amalthea
	{
		"Jupiter",
		"Amalthea",		{"Amalthea", "A}eA"},		"",
		131.0, 73.0, 67.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 181400.0, 0.0032, 155.873, 185.194, 0.380, 108.946,  722.6317143,  0.498,   0.196,   0.393, 268.057, 64.495
	},
	//--  Thebe
	{
		"Jupiter",
		"Thebe",		{"Thebe", "e[x"},				"",
		55.0, 55.5, 45.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 221900.0, 0.0176, 234.269, 135.956, 1.080, 235.694,  533.7002568,  0.675,   0.398,   0.797, 268.057, 64.495
	},
	//--  Adrastea
	{
		"Jupiter",
		"Adrastea",		{"Adrastea", "AhXeA"},		"",
		13.0, 10.0, 8.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 129000.0, 0.0018, 328.047, 135.673, 0.054, 228.378, 1206.9988064,  0.298,   0.058,   0.116, 268.057, 64.496
	},
	//--  Metis
	{
		"Jupiter",
		"Metis",		{"Metis", "eBX"},			"",
		20.0, 20.0, 20.0,
		SAT_ORBIT_LAPLACE,
		2450464.5, 128000.0, 0.0012, 297.177, 276.047, 0.019, 146.912, 1221.2545982,  0.295,   0.057,   0.115, 268.057, 64.496
	},
	//--  Himalia
	{ 
		"Jupiter",
		"Himalia",		{"Himalia", "q}A"},			"",
		85.0, 85.0, 85.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 11461000.0, 0.1623, 331.995,  68.721, 27.496, 57.245,    1.4367718, 250.56, 137.16,  282.90, 275.667, 67.429
	}, 
	//--  Elara
	{
		"Jupiter",
		"Elara",		{"Elara", "G"},				"",
		40.0, 40.0, 40.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 11741000.0, 0.2174, 143.591, 332.962, 26.627, 109.373,   1.3865491, 259.64, 126.42,  252.49, 273.200, 68.246
	},
	//--  Pasiphae
	{
		"Jupiter",
		"Pasiphae",		{"Pasiphae", "pVt@G"},		"",
		18.0, 18.0, 18.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 23624000.0, 0.4090, 170.450, 280.193, 151.431, 312.990,  0.4841107, 743.63,  80.83,   81.01, 273.440, 67.645
	},
	//--  Sinope
	{
		"Jupiter",
		"Sinope",		{"Sinope", "Vmy"},			"",
		14.0, 14.0, 14.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 23939000.0, 0.2495, 346.394, 168.397, 158.109, 303.081,  0.4743709, 758.90,  89.27,   87.54, 273.266, 66.880
	},
	//--  Lysithea
	{
		"Jupiter",
		"Lysithea",		{"Lysithea", "VeA"},			"",
		12.0, 12.0, 12.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 11717000.0, 0.1124,  49.486, 329.121,  28.302,   5.528,  1.3888799, 259.20, 131.52,  299.88, 271.356, 67.115
	},
	//--  Carme
	{
		"Jupiter",
		"Carme",		{"Carme", "J"},				"",
		15.0, 15.0, 15.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 23404000.0, 0.2533,  28.199, 234.027, 164.907, 113.738,  0.4903509, 734.17,  81.06,   88.53, 272.620, 66.689
	},
	//--  Ananke
	{
		"Jupiter",
		"Ananke",		{"Ananke", "AiP"},			"",
		10.0, 10.0, 10.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 21276000.0, 0.2435, 100.619, 248.793, 148.889,   7.615,  0.5716368, 629.77, 140.85,  108.96,  279.087, 66.152
	},
	//--  Leda
	{
		"Jupiter",
		"Leda",			{"Leda", "_"},				"",
		5.0, 5.0, 5.0,
		SAT_ORBIT_LAPLACE,
		2451544.5, 11165000.0, 0.1636, 272.349, 228.076,  27.457, 217.137,  1.4942498, 240.92, 142.57,  296.66, 271.668, 66.848
	},
	//--  Callirrhoe
	{
		"Jupiter",
		"Callirrhoe",	{"Callirrhoe", "Callirrhoe"},	"",
		4.3, 4.3, 4.3,
		SAT_ORBIT_LAPLACE,
		2452400.5, 
		24103000.0, 0.2829,  30.477, 152.818, 147.167, 289.331, 0.4744544, 758.77, 119.99, 89.00, 272.836, 66.537
	},
	//--  Themisto
	{
		"Jupiter",
		"Themisto",		{"Themisto", "Themisto"},		"",
		4.0, 4.0, 4.0,
		SAT_ORBIT_LAPLACE,
		2452400.5, 
		7284000.0, 0.2428, 219.127, 162.190, 43.254, 189.059, 2.7688081, 130.02, 682.28, 532.51, 272.709, 66.701
	},
	//--  Magaclite
	{
		"Jupiter",
		"Magaclite",	{"Magaclite", "Magaclite"},		"",
		2.7, 2.7, 2.7,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23493000.0, 0.4198, 287.673, 189.295, 152.766, 283.674, 0.4781739, 752.86, 76.23, 78.97, 273.239, 66.767 
	},
	//--  Taygete
	{
		"Jupiter",
		"Taygete",		{"Taygete", "Taygete"},			"",
		2.5, 2.5, 2.5,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23280000.0, 0.2525, 240.039, 154.122, 165.268, 310.109, 0.4915295, 732.41, 80.91, 88.46, 273.156, 66.761 
	},
	//--  Chaldene
	{
		"Jupiter",
		"Chaldene",		{"Chaldene", "Chaldene"},		"",
		1.9, 1.9, 1.9,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23100000.0, 0.2521, 255.816, 330.618, 165.190, 141.954, 0.4974307, 723.72, 81.77, 89.63, 273.258, 66.763 
	},
	//--  Harpalyke
	{
		"Jupiter",
		"Harpalyke",	{"Harpalyke", "Harpalyke"},		"",
		2.2, 2.2, 2.2,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		20858000.0, 0.2269, 140.733, 351.333, 148.644, 34.083, 0.5775499, 623.32, 147.16, 111.62, 273.235, 66.919 
	},
	//--  Kalyke
	{
		"Jupiter",
		"Kalyke",		{"Kalyke", "Kalyke"},			"",
		2.6, 2.6, 2.6,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23483000.0, 0.2471, 232.431, 311.538, 165.179, 52.850, 0.4851387, 742.06, 80.93, 87.83, 273.223, 66.766 
	},
	//--  Iocaste
	{
		"Jupiter",
		"Iocaste",		{"Iocaste", "Iocaste"},			"",
		2.6, 2.6, 2.6,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		21060000.0, 0.2158, 68.609, 345.906, 149.425, 274.125, 0.5699812, 631.60, 145.51, 111.13, 273.218, 66.883
	},
	//--  Erinome
	{
		"Jupiter",
		"Erinome",		{"Erinome", "Erinome"},			"",
		1.6, 1.6, 1.6,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23196000.0, 0.2664, 20.138, 326.051, 164.936, 323.577, 0.4941918, 728.46, 80.51, 88.33, 273.208, 66.761 
	},
	//--  Isonoe
	{
		"Jupiter",
		"Isonoe",		{"Isonoe", "Isonoe"},			"",
		1.9, 1.9, 1.9,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23155000.0, 0.2471, 124.900, 186.821, 165.272, 135.428, 0.4957083, 726.23, 81.68, 89.39, 273.237, 66.798 
	},
	//--  Praxidike
	{
		"Jupiter",
		"Praxidike",	{"Praxidike", "Praxidike"},			"",
		3.4, 3.4, 3.4,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		20908000.0, 0.2311, 196.408, 252.047, 148.975, 285.062, 0.5756395, 625.39, 144.74, 111.08, 273.018, 66.760
	},
	//--  Autonoe
	{
		"Jupiter",
		"Autonoe",		{"Autonoe", "Autonoe"},				"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		24046000.0, 0.3168, 59.247, 188.268, 152.416, 277.139, 0.4730917, 760.95, 92.01, 84.84, 273.181, 66.815 
	},
	//--  Thyone
	{
		"Jupiter",
		"Thyone",		{"Thyone", "Thyone"},				"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		20939000.0, 0.2286, 101.517, 13.671, 148.509, 237.437, 0.5739687, 627.21, 147.37, 110.91, 273.541, 66.846 
	},
	//--  Hermippe
	{
		"Jupiter",
		"Hermippe",		{"Hermippe", "Hermippe"},			"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		21131000.0, 0.2096, 308.199, 258.257, 150.725, 335.424, 0.5679131, 633.90, 137.06, 110.62, 273.271, 66.864 
	},
	//--  Aitne
	{
		"Jupiter",
		"Aitne",		{"Aitne", "Aitne"},					"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23229000.0, 0.2643, 110.677, 167.511, 165.091, 15.915, 0.4930324, 730.18, 80.45, 88.26, 273.158, 66.812 
	},
	//--  Eurydome
	{
		"Jupiter",
		"Eurydome",		{"Eurydome", "Eurydome"},			"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		22865000.0, 0.2759, 231.789, 358.457, 150.274, 308.853, 0.5018606, 717.33, 111.64, 93.33, 273.195, 66.716 
	},
	//--  Euanthe
	{
		"Jupiter",
		"Euanthe",		{"Euanthe", "Euanthe"},				"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		20797000.0, 0.2321, 325.459, 113.555, 148.910, 258.578, 0.5801858, 620.49, 144.27, 111.69, 273.207, 66.739 
	},
	//--  Euporie
	{
		"Jupiter",
		"Euporie",		{"Euporie", "Euporie"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		19304000.0, 0.1432, 89.231, 275.965, 145.767, 62.671, 0.6536611, 550.74, 242078.00, 139.43, 273.181, 66.708 
	},
	//--  Orthosie
	{
		"Jupiter",
		"Orthosie",		{"Orthosie", "Orthosie"},			"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		20720000.0, 0.2808, 222.682, 341.276, 145.921, 226.608, 0.5782606, 622.56, 142.35, 107.48, 273.134, 66.956 
	},
	//--  Sponde
	{
		"Jupiter",
		"Sponde",		{"Sponde", "Sponde"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23487000.0, 0.3121, 71.674, 228.603, 150.998, 123.963, 0.4810619, 748.34, 98.08, 87.00, 273.138, 66.737
	},
	//--  Kale
	{
		"Jupiter",
		"Kale",			{"Kale", "Kale"},					"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23217000.0, 0.2599, 52.377, 272.074, 164.996, 64.620, 0.4935058, 729.47, 80.78, 88.45, 273.325, 66.774 
	},
	//--  Pasithee
	{
		"Jupiter",
		"Pasithee",		{"Pasithee", "Pasithee"},			"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452400.5,
		23004000.0, 0.2675, 241.461, 282.394, 165.138, 333.554, 0.5003861, 719.44, 80.78, 89.20, 273.156, 66.761 
	},
	//--  Hegemone
	{
		"Jupiter",
		"Hegemone",		{"Hegemone", "Hegemone"},			"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23577000.0, 0.3396, 225.523, 122.548, 154.186, 336.831, 0.4865632, 739.88, 86.60, 85.30, 273.251, 66.734 
	},
	//--  Mneme
	{
		"Jupiter",
		"Mneme",		{"Mneme", "Mneme"},					"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		21035000.0, 0.2301, 49.615, 266.383, 148.693, 21.543, 0.5806109, 620.04, 148.18, 112.23, 273.243, 66.598 
	},
	//--  Aoede
	{
		"Jupiter",
		"Aoede",		{"Aoede", "Aoede"},					"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23980000.0, 0.4311, 77.962, 69.607, 158.260, 186.565, 0.4727534, 761.50, 69.15, 76.80, 273.306, 66.775 
	},
	//--  Thelxinoe
	{
		"Jupiter",
		"Thelxinoe",	{"Thelxinoe", "Thelxinoe"},			"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		21164000.0, 0.2194, 323.396, 268.092, 151.370, 177.578, 0.5731656, 628.09, 130.74, 110.40, 273.335, 66.729 
	},
	//--  Arche
	{
		"Jupiter",
		"Arche",		{"Arche", "Arche"},					"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23355000.0, 0.2496, 188.816, 297.166, 165.017, 351.662, 0.4918401, 731.95, 81.50, 88.82, 273.233, 66.797 
	},
	//--  Kallichore
	{
		"Jupiter",
		"Kallichore",	{"Kallichore", "Kallichore"},		"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23288000.0, 0.2503, 22.395, 313.118, 165.127, 39.114, 0.4940109, 728.73, 81.37, 88.96, 273.295, 66.789 
	},
	//--  Helike
	{
		"Jupiter",
		"Helike",		{"Helike", "Helike"},				"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		21069000.0, 0.1506, 302.710, 51.627, 154.853, 95.389, 0.5747850, 626.32, 126.33, 114.22, 273.287, 66.793 
	},
	//--  Carpo
	{
		"Jupiter",
		"Carpo",		{"Carpo", "Carpo"},					"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		17058000.0, 0.4316, 89.669, 258.622, 51.628, 38.836, 0.7889609, 456.30, 6815613.03, 112.62, 273.325, 67.004 
	},
	//--  Eukelade
	{
		"Jupiter",
		"Eukelade",		{"Eukelade", "Eukelade"},			"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23328000.0, 0.2634, 326.502, 102.770, 165.240, 205.644, 0.4928329, 730.47, 80.32, 88.22, 273.244, 66.754 
	},
	//--  Cyllene
	{
		"Jupiter",
		"Cyllene",		{"Cyllene", "Cyllene"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23809000.0, 0.4115, 217.238, 358.536, 150.389, 270.850, 0.4787240, 752.00, 81.05, 80.07, 273.399, 66.714 
	},
	//--  S/2003J2
	{
		"Jupiter",
		"S/2003 J2",		{"S/2003 J2", "S/2003 J2"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		28455000.0, 0.4074, 190.201, 38.754, 157.321, 0.359, 0.3667668, 981.55, 60.48, 62.86, 273.212, 66.862 
	},
	//--  S/2003J3
	{
		"Jupiter",
		"S/2003 J3",		{"S/2003 J3", "S/2003 J3"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		20224000.0, 0.1969, 71.858, 11.175, 147.541, 238.749, 0.6165665, 583.88, 181.51, 122.80, 273.534, 66.855 
	},
	//--  S/2003J4
	{
		"Jupiter",
		"S/2003 J4",		{"S/2003 J4", "S/2003 J4"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23933000.0, 0.3620, 213.575, 139.691, 149.574, 192.424, 0.4766595, 755.26, 90.39, 83.06, 273.154, 66.748 
	},
	//--  S/2003J5
	{
		"Jupiter",
		"S/2003 J5",		{"S/2003 J5", "S/2003 J5"},				"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23498000.0, 0.2476, 104.063, 227.212, 165.239, 186.708, 0.4873193, 738.74, 80.82, 87.98, 273.283, 66.805 
	},
	//--  S/2003J9
	{
		"Jupiter",
		"S/2003 J9",		{"S/2003 J9", "S/2003 J9"},				"",
		0.5, 0.5, 0.5,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23388000.0, 0.2627, 307.794, 243.751, 165.076, 55.250, 0.4909301, 733.30, 80.21, 87.88, 273.177, 66.779 
	},
	//--  S/2003J10
	{
		"Jupiter",
		"S/2003 J10",	{"S/2003 J10", "S/2003 J10"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23044000.0, 0.4294, 188.555, 167.277, 165.069, 163.968, 0.5026164, 716.25, 68.05, 80.32, 273.227, 66.798 
	},
	//--  S/2003J12
	{
		"Jupiter",
		"S/2003 J12",	{"S/2003 J12", "S/2003 J12"},				"",
		0.5, 0.5, 0.5,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		17833000.0, 0.4920, 26.024, 246.715, 151.104, 74.057, 0.7351124, 489.72, 97.95, 109.47, 273.299, 66.911 
	},
	//--  S/2003J14
	{
		"Jupiter",
		"S/2003 J14",	{"S/2003 J14", "S/2003 J14"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		24543000.0, 0.3245, 152.443, 247.145, 144.969, 324.692, 0.4620274, 779.17, 108.82, 84.35, 273.997, 66.902 
	},
	//--  S/2003J15
	{
		"Jupiter",
		"S/2003 J15",	{"S/2003 J15", "S/2003 J15"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		22630000.0, 0.1944, 25.266, 359.009, 146.551, 245.193, 0.5219101, 689.77, 187.98, 105.32, 273.080, 66.311
	},
	//--  S/2003J16
	{
		"Jupiter",
		"S/2003 J16",	{"S/2003 J16", "S/2003 J16"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		20956000.0, 0.2266, 68.386, 313.713, 148.512, 25.520, 0.5840989, 616.33, 151.12, 113.24, 273.242, 66.591 
	},
	//--  S/2003J17
	{
		"Jupiter",
		"S/2003 J17",	{"S/2003 J17", "S/2003 J17"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		22983000.0, 0.2381, 347.546, 35.064, 164.921, 305.904, 0.5038397, 714.51, 83.56, 91.35, 273.190, 66.782 
	},
	//--  S/2003J18
	{
		"Jupiter",
		"S/2003 J18",	{"S/2003 J18", "S/2003 J18"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		20426000.0, 0.0601, 90.657, 287.616, 145.908, 164.666, 0.6034348, 596.58, 282579.95, 134.78, 272.778, 66.632 
	},
	//--  S/2003J19
	{
		"Jupiter",
		"S/2003 J19",	{"S/2003 J19", "S/2003 J19"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23535000.0, 0.2559, 194.629, 113.418, 165.154, 40.349, 0.4862032, 740.43, 80.33, 87.52, 273.267, 66.795 
	},
	//--  S/2003J23
	{
		"Jupiter",
		"S/2003 J23",	{"S/2003 J23", "S/2003 J23"},				"",
		1.0, 1.0, 1.0,
		SAT_ORBIT_LAPLACE,
		2452800.5,
		23566000.0, 0.2738, 264.149, 46.098, 146.397, 52.845, 0.4915024, 732.45, 130.07, 92.89, 272.604, 66.531 
	},



//===============
//  Saturn (59)
//===============
	//--  Mimas
	{
		"Saturn",
		"Mimas",		{"Mimas", "~}X"},				"mimas.jpg",
		209.1, 196.2, 191.4,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		185540.0, 0.0196, 14.352, 255.312, 1.572, 153.152, 381.9944522, 0.942, 0.493, 0.986, 40.590, 83.539
	},
	//--  Enceladus
	{
		"Saturn",
		"Enceladus",	{"Enceladus", "GPhDX"},	"enceladus.jpg",
		256.3, 247.3, 244.6,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		238040.0, 0.0047, 211.923, 197.047, 0.009, 93.204, 262.7318959, 1.370, 1.306, 2.364, 40.587, 83.539 
	},
	//--  Tethys
	{
		"Saturn",
		"Tethys",		{"Tethys", "eeBX"},			"",
		535.6, 528.2, 525.8,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		294670.0, 0.0001, 262.845, 189.003, 1.091, 330.882, 190.6979135, 1.888, 2.490, 4.982, 40.581, 83.539 
	},
	//--  Dione
	{
		"Saturn",
		"Dione",		{"Dione", "fBIl"},			"",
		560.0, 560.0, 560.0,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		377420.0, 0.0022, 168.820, 65.990, 0.028, 168.909, 131.5349307, 2.737, 5.854, 11.716, 40.554, 83.542 
	}, 
	//--  Rhea
	{
		"Saturn",
		"Rhea",			{"Rhea", "A"},				"",
		764.0, 764.0, 764.0,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		527070.0, 0.0010, 256.609, 311.551, 0.331, 311.531, 79.6900463, 4.518, 33.914, 35.929, 40.387, 83.556 
	},
	//--  Titan
	{
		"Saturn",
		"Titan",		{"Titan", "^C^"},			"titan.jpg",
		2575.0,  2575.0, 2575.0,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		1221870.0, 0.0288, 185.671, 15.154, 0.280, 24.502, 22.5769762, 15.95, 325.21, 607.56, 36.470, 83.936 
	},
	//--  Hyperion
	{
		"Saturn",
		"Hyperion",		{"Hyperion", "nCyI"},		"",
		180.0, 140.0, 112.5,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		1500880.0, 0.0274, 324.183, 295.906, 0.630, 264.022, 16.9199583, 21.28, 116.69, 154.16, 37.258, 83.819 
	},
	//--  Iapetus
	{
		"Saturn",
		"Iapetus",		{"Iapetus", "CAygDX"},		"Iapetus.jpg",
		718.0, 718.0, 718.0,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		3560840.0, 0.0283, 275.921, 356.029, 7.489, 75.831, 4.5379503, 79.33, 1632.63, 3082.10, 288.818, 78.667 
	},
	//--  Phoebe
	{
		"Saturn",
		"Phoebe",		{"Phoebe", "tF[x"},			"",
		110.0, 110.0, 110.0,
		SAT_ORBIT_LAPLACE,
		2453005.5,
		12947780.0, 0.1635, 345.582, 287.593, 175.986, 241.570, 0.6541824, 550.31, 410.40, 613.95, 277.897, 67.124 
	},
	//--  Janus
	{
		"Saturn",
		"Janus",		{"Janus", "kX"},				"",
		97.0, 95.0, 77.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		151460.0, 0.0068, 241.778, 242.754, 0.163, 46.899, 518.2388834, 0.695, 0.241, 0.482, 0,0 
	},
	//--  Epimetheus
	{
		"Saturn",
		"Epimetheus",	{"Epimetheus", "GseEX"},	"",
		69.0, 55.0, 55.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		151410.0, 0.0098, 312.630, 308.322, 0.351, 85.244, 518.4828200, 0.694, 0.240, 0.481, 0,0 
	},
	//--  Helene
	{
		"Saturn",
		"Helene",		{"Helene", "wl"},			"",
		18.0, 16.0, 15.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		377420.0, 0.0071, 292.056, 134.070, 0.213, 40.039, 131.5349309, 2.737, 5.823, 11.704, 0,0
	},
	//--  Telesto
	{
		"Saturn",
		"Telesto",		{"Telesto", "eXg"},			"",
		15.0, 12.5, 7.5,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		294710.0, 0.0002, 341.795, 200.143, 1.180, 300.256, 190.6978386, 1.888, 2.488, 4.982, 0,0 
	},
	//--  Calypso
	{
		"Saturn",
		"Calypso",		{"Calypso", "Jv\"},			"",
		15.0, 8.0, 8.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		294710.0, 0.0005, 234.788, 101.961, 1.499, 25.327, 190.6978386, 1.888, 2.487, 4.983, 0,0
	},
	//--  Atlas
	{
		"Saturn",
		"Atlas",		{"Atlas", "AgX"},			"",
		18.5, 17.2, 13.5,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		137670.0, 0.0012, 331.521, 157.738, 0.003, 0.500, 598.3099854, 0.602, 0.172, 0.344, 0,0
	},
	//--  Prometheus
	{
		"Saturn",
		"Prometheus",	{"Prometheus", "veEX"},	"",
		74.0, 50.0, 34.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		139380.0, 0.0022, 164.389, 242.224, 0.008, 259.504, 587.2852370, 0.613, 0.179, 0.359,  0,0
	},
	//--  Pandora
	{
		"Saturn",
		"Pandora",		{"Pandora", "ph"},			"",
		55.0, 44.0, 31.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		141720.0, 0.0042, 83.461, 202.697, 0.050, 327.215, 572.7885228, 0.629, 0.190, 0.381,  0,0 
	},
	//--  Pan
	{
		"Saturn",
		"Pandora",		{"Pan", "p"},					"",
		10.0, 10.0, 10.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		133580.0, 0.0000, 139.318, 246.065, 0.001, 40.557, 626.0317369, 0.575, 0.154, 0.309,  0,0
	},
	//--  Methone
	{
		"Saturn",
		"Methone",		{"Methone", "Methone"},			"",
		1.5, 1.5, 1.5,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		194440.0, 0.0001, 292.695, 163.735, 0.007, 321.745, 356.5860539, 1.010, 0.405, 0.987,  0,0
	},
	//--  Pallene
	{
		"Saturn",
		"Pallene",		{"Pallene", "Pallene"},			"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		212280.0, 0.0040, 216.475, 125.909, 0.181, 114.430, 312.0271303, 1.154, 0.790, 1.582,  0,0
	},
	//--  Polydeuces
	{
		"Saturn",
		"Polydeuces",	{"Polydeuces", "Polydeuces"},	"",
		1.7, 1.7, 1.7,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		377200.0, 0.0192, 200.028, 191.220, 0.177, 304.799, 131.5347441, 2.737, 5.879, 11.938,  0,0 
	},
	//--  Daphnis
	{
		"Saturn",
		"Daphnis",		{"Daphnis", "Daphnis"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_EQUATORIAL,
		2453005.5,
		136500.0, 0.0000, 0.000, 306.135, 0.000, 0.000, 605.9791537, 0.594, 0.000, 0.000,  0,0 
	},
	//--  Ymir
	{
		"Saturn",
		"Ymir",			{"Ymir", "Ymir"},				"",
		9.0, 9.0, 9.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		23040000.0, 0.3349, 22.668, 244.521, 173.125, 194.086, 0.2737342, 1315.14, 218.68, 279.16,  0,0
	},
	//--  Paaliaq
	{
		"Saturn",
		"Paaliaq",		{"Paaliaq", "Paaliaq"},				"",
		11.0, 11.0, 11.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		15200000.0, 0.3630, 238.868, 351.882, 45.084, 326.972, 0.5240593, 686.95, 577.17, 534.76,  0,0 
	},
	//--  Tarvos
	{
		"Saturn",
		"Tarvos",		{"Tarvos", "Tarvos"},				"",
		7.5, 7.5, 7.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		17983000.0, 0.5305, 273.591, 282.384, 33.827, 102.992, 0.3886712, 926.23, 194.07, 272.60, 0,0 
	},
	//--  Ijiraq
	{
		"Saturn",
		"Ijiraq",		{"Ijiraq", "Ijiraq"},				"",
		6.0, 6.0, 6.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		11124000.0, 0.3164, 85.587, 64.302, 46.448, 136.317, 0.7974833, 451.42, 23804.08, 868.55,  0,0 
	},
	//--  Suttungr
	{
		"Saturn",
		"Suttungr",		{"Suttungr", "Suttungr"},			"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19459000.0, 0.1140, 35.556, 340.476, 175.815, 228.476, 0.3540964, 1016.67, 292.86, 402.18,  0,0
	},
	//--  Kiviuq
	{
		"Saturn",
		"Kiviuq",		{"Kiviuq", "Kiviuq"},				"",
		8.0, 8.0, 8.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		11110000.0, 0.3289, 82.273, 221.290, 45.708, 359.832, 0.8013910, 449.22, 29829.96, 845.64,  0,0 
	},
	//--  Mundilfari
	{
		"Saturn",
		"Mundilfari",	{"Mundilfari", "Mundilfari"},		"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18628000.0, 0.2099, 310.214, 111.388, 167.473, 83.186, 0.3778461, 952.77, 312.49, 417.31,  0,0
	},
	//--  Albiorix
	{
		"Saturn",
		"Albiorix",		{"Albiorix", "Albiorix"},			"",
		16.0, 16.0, 16.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		16182000.0, 0.4770, 55.390, 58.820, 34.208, 102.313, 0.4595051, 783.45, 249.72, 358.87,  0,0 
	},
	//--  Skathi
	{
		"Saturn",
		"Skathi",		{"Skathi", "Skathi"},			"",
		4.0, 4.0, 4.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		15540000.0, 0.2698, 201.818, 148.572, 152.630, 283.851, 0.4943686, 728.20, 474.83, 543.98,  0,0
	},
	//--  Erriapo
	{
		"Saturn",
		"Erriapo",		{"Erriapo", "Erriapo"},			"",
		5.0, 5.0, 5.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		17343000.0, 0.4724, 281.757, 321.903, 34.692, 150.901, 0.4132263, 871.19, 219.56, 323.76,  0,0 
	},
	//--  Siarnaq
	{
		"Saturn",
		"Siarnaq",		{"Siarnaq", "Siarnaq"},			"",
		20.0, 20.0, 20.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		17531000.0, 0.2960, 65.344, 225.943, 46.002, 47.438, 0.4019953, 895.53, 455.51, 454.99,  0,0 
	},
	//--  Thrymr
	{
		"Saturn",
		"Thrymr",		{"Thrymr", "Thrymr"},			"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		20314000.0, 0.4664, 63.435, 112.713, 175.802, 223.714, 0.3290354, 1094.11, 221.86, 296.49,  0,0
	},
	//--  Narvi
	{
		"Saturn",
		"Narvi",		{"Narvi", "Narvi"},				"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19007000.0, 0.4308, 170.946, 130.415, 145.824, 173.125, 0.3586157, 1003.86, 341.29, 344.86,  0,0
	},
	//--  Aegir
	{
		"Saturn",
		"Aegir",		{"Aegir", "Aegir"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		20751000.0, 0.2520, 244.226, 37.823, 166.700, 181.006, 0.3221416, 1117.52, 273.57, 350.02,  0,0
	},
	//--  Bebhionn
	{
		"Saturn",
		"Bebhionn",		{"Bebhionn", "Bebhionn"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		17119000.0, 0.4691, 358.623, 190.653, 35.012, 199.576, 0.4312213, 834.84, 236.35, 341.80,  0,0 
	},
	//--  Bergelmir
	{
		"Saturn",
		"Bergelmir",	{"Bergelmir", "Bergelmir"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19336000.0, 0.1428, 133.980, 325.300, 158.574, 202.082, 0.3579451, 1005.74, 360.21, 425.17,  0,0
	},
	//--  Bestla
	{
		"Saturn",
		"Bestla",		{"Bestla", "Bestla"},				"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		20192000.0, 0.5176, 81.666, 348.100, 145.162, 290.006, 0.3306624, 1088.72, 285.00, 299.36,  0,0
	},
	//--  Farbauti
	{
		"Saturn",
		"Farbauti",		{"Farbauti", "Farbauti"},			"",
		2.5, 2.5, 2.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		20377000.0, 0.2396, 344.816, 297.916, 156.393, 135.412, 0.3316291, 1085.55, 332.39, 374.42,  0,0
	},
	//--  Fenrir
	{
		"Saturn",
		"Fenrir",		{"Fenrir", "Fenrir"},				"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		22454000.0, 0.1363, 120.264, 146.614, 164.955, 225.155, 0.2856349, 1260.35, 275.80, 330.95,  0,0
	},
	//--  Fornjot
	{
		"Saturn",
		"Fornjot",		{"Fornjot", "Fornjot"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		25146000.0, 0.2066, 322.510, 228.414, 170.434, 258.322, 0.2409308, 1494.20, 223.25, 267.27,  0,0
	},
	//--  Hati
	{
		"Saturn",
		"Hati",			{"Hati", "Hati"},					"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19846000.0, 0.3713, 18.863, 177.556, 165.830, 322.417, 0.3466171, 1038.61, 262.40, 340.08,  0,0 
	},
	//--  Hyrokkin
	{
		"Saturn",
		"Hyrokkin",		{"Hyrokkin", "Hyrokkin"},			"",
		4.0, 4.0, 4.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18437000.0, 0.3336, 278.948, 83.635, 151.450, 51.519, 0.3863244, 931.86, 376.27, 406.36,  0,0 
	},
	//--  Kari
	{
		"Saturn",
		"Kari",			{"Kari", "Kari"},					"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		22089000.0, 0.4770, 172.413, 224.636, 156.271, 288.034, 0.2924526, 1230.97, 228.64, 269.79,  0,0
	},
	//--  Loge
	{
		"Saturn",
		"Loge",			{"Loge", "Loge"},					"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		23058000.0, 0.1856, 41.204, 235.547, 167.872, 351.003, 0.2745243, 1311.36, 252.38, 308.84,  0,0 
	},
	//--  Skoll
	{
		"Saturn",
		"Skoll",		{"Skoll", "Skoll"},					"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		17665000.0, 0.4641, 199.662, 243.323, 161.188, 301.059, 0.4098870, 878.29, 286.33, 368.06,  0,0
	},
	//--  Surtur
	{
		"Saturn",
		"Surtur",		{"Surtur", "Surtur"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		22704000.0, 0.4507, 18.187, 44.838, 177.545, 308.564, 0.2774868, 1297.36, 980.12, 18420.94,  0,0
	},
	//--  S/2004_S7
	{
		"Saturn",
		"S/2004 S7",	{"S/2004 S7", "S/2004 S7"},				"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		20999000.0, 0.5299, 82.183, 97.719, 166.185, 339.338, 0.3157236, 1140.24, 210.31, 271.78,  0,0
	},
	//--  S/2004_S12
	{
		"Saturn",
		"S/2004 S12",	{"S/2004 S12", "S/2004 S12"},			"",
		2.5, 2.5, 2.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19878000.0, 0.3260, 85.079, 24.685, 165.282, 306.051, 0.3441054, 1046.19, 272.60, 350.68,  0,0
	},
	//--  S/2004_S13
	{
		"Saturn",
		"S/2004 S13",	{"S/2004 S13", "S/2004 S13"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18404000.0, 0.2586, 346.549, 63.307, 168.789, 206.033, 0.3856542, 933.48, 302.27, 410.16,  0,0
	},
	//--  S/2004_S17
	{
		"Saturn",
		"S/2004 S17",	{"S/2004 S17", "S/2004 S17"},			"",
		2.0, 2.0, 2.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		19447000.0, 0.1793, 180.348, 250.695, 168.237, 26.166, 0.3547847, 1014.70, 300.92, 397.33,  0,0
	},
	//--  S/2006_S1
	{
		"Saturn",
		"S/2006 S1",	{"S/2006 S1", "S/2006 S1"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18790000.0, 0.1172, 159.254, 111.832, 156.309, 337.337, 0.3736901, 963.37, 406.86, 457.01,  0,0
	},
	//--  S/2006_S3
	{
		"Saturn",
		"S/2006 S3",	{"S/2006 S3", "S/2006 S3"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		22096000.0, 0.3979, 184.948, 177.783, 158.288, 208.277, 0.2933493, 1227.21, 244.16, 288.94,  0,0
	},
	//--  S/2006_S4
	{
		"Saturn",
		"S/2006 S4",	{"S/2006 S4", "S/2006 S4"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18206000.0, 0.3259, 202.413, 322.447, 179.837, 41.835, 0.3907996, 921.19, 114.57, 103.03,  0,0
	},
	//--  S/2006_S6
	{
		"Saturn",
		"S/2006 S6",	{"S/2006 S6", "S/2006 S6"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18811000.0, 0.2164, 245.736, 177.102, 163.317, 24.162, 0.3731588, 964.74, 325.57, 417.38,  0,0 
	},
	//--  S/2007_S1
	{
		"Saturn",
		"S/2007 S1",	{"S/2007 S1", "S/2007 S1"},			"",
		3.5, 3.5, 3.5,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18009000.0, 0.1603, 30.966, 337.909, 46.089, 82.039, 0.4056433, 887.48, 884.45, 583.74,  0,0
	},
	//--  S/2007_S2
	{
		"Saturn",
		"S/2007 S2",	{"S/2007 S2", "S/2007 S2"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		16725000.0, 0.1793, 75.525, 331.240, 174.043, 126.700, 0.4454995, 808.08, 348.69, 507.78,  0,0
	},
	//--  S/2007_S3
	{
		"Saturn",
		"S/2007 S3",	{"S/2007 S3", "S/2007 S3"},			"",
		3.0, 3.0, 3.0,
		SAT_ORBIT_ECLIPTIC,
		2451600.5,
		18975000.0, 0.1851, 304.066, 17.345, 174.528, 106.806, 0.3681717, 977.80, 294.52, 405.58,  0,0
	},


//=================
//   Uranus (27) 
//=================
	//--  Ariel
	{
		"Uranus",
		"Ariel",		{"Ariel", "GAG"},			"",
		581.1, 577.9, 577.7,
		SAT_ORBIT_EQUATORIAL,
		2444239.5,
		190900.0, 0.0012, 115.349,   39.481,   180.041,  22.394, 142.8356579,  2.520, 28.788,  57.248, 0,0
		//190900.0, 0.0012, 115.349,   39.481,   0.041,  22.394, 142.8356579,  2.520, 28.788,  57.248, 0,0
	},
	//--  Umbriel
	{
		"Uranus",
		"Umbriel",		{"Umbriel", "EuG"},		"",
		584.7, 584.7, 584.7,
		SAT_ORBIT_EQUATORIAL,
		2444239.5,
		266000.0, 0.0039,  84.709,   12.469,   180.128,  33.485,  86.8688879,  4.144, 63.146, 126.951, 0,0
		//266000.0, 0.0039,  84.709,   12.469,   0.128,  33.485,  86.8688879,  4.144, 63.146, 126.951, 0,0
	},
	//--  Titania
	{
		"Uranus",
		"Titania",		{"Titania", "eB^jA"},		"",
		788.9, 788.9, 788.9,
		SAT_ORBIT_EQUATORIAL,
		2444239.5,
		436300.0, 0.0011, 284.400,   24.614,   180.079,  99.771,  41.3514246,  8.706, 161.525, 195.369, 0,0
		//436300.0, 0.0011, 284.400,   24.614,   0.079,  99.771,  41.3514246,  8.706, 161.525, 195.369, 0,0
	},
	//--  Oberon
	{
		"Uranus",
		"Oberon",		{"Oberon", "Ix"},			"",
		761.4, 761.4, 761.4,
		SAT_ORBIT_EQUATORIAL,
		2444239.5,
		583500.0, 0.0014, 104.400,  283.088,   180.068, 279.771,  26.7394888, 13.46, 161.52,  195.37, 0,0
		//583500.0, 0.0014, 104.400,  283.088,   0.068, 279.771,  26.7394888, 13.46, 161.52,  195.37, 0,0
	},
	//--  Miranda
	{
		"Uranus",
		"Miranda",		{"Miranda", "~_"},			"",
		240.4, 234.2, 232.9,
		SAT_ORBIT_EQUATORIAL,
		2444239.5,
		129900.0, 0.0013,  68.312,  311.330,   184.338, 326.438, 254.6906576,  1.413,  8.913,  17.727, 0,0
		//129900.0, 0.0013,  68.312,  311.330,   4.338, 326.438, 254.6906576,  1.413,  8.913,  17.727, 0,0
	}, 
	//--  Cordelia
	{
		"Uranus",
		"Cordelia",		{"Cordelia", "Cordelia"},			"",
		20.1, 20.1, 20.1,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		49800.0, 0.0003, 136.827, 254.805, 180.085, 38.374, 1074.5183162, 0.335, 0.328, 0.657,  0,0
		//49800.0, 0.0003, 136.827, 254.805, 0.085, 38.374, 1074.5183162, 0.335, 0.328, 0.657,  0,0
	}, 
	//--  Ophelia
	{
		"Uranus",
		"Ophelia",		{"Ophelia", "Ophelia"},			"",
		21.4, 21.4, 21.4,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		53800.0, 0.0099, 17.761, 116.259, 180.104, 164.048, 956.4283330, 0.376, 0.431, 0.862,  0,0
		//53800.0, 0.0099, 17.761, 116.259, 0.104, 164.048, 956.4283330, 0.376, 0.431, 0.862,  0,0
	}, 
	//--  Bianca
	{
		"Uranus",
		"Bianca",		{"Bianca", "Bianca"},			"",
		25.7, 25.7, 25.7,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		59200.0, 0.0009, 8.293, 138.486, 180.193, 93.220, 828.3879607, 0.435, 0.603, 1.206,  0,0
		//59200.0, 0.0009, 8.293, 138.486, 0.193, 93.220, 828.3879607, 0.435, 0.603, 1.206,  0,0
	}, 
	//--  Cressida
	{
		"Uranus",
		"Cressida",		{"Cressida", "Cressida"},		"",
		39.8, 39.8, 39.8,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		61800.0, 0.0004, 44.236, 233.795, 180.006, 99.403, 776.5824144, 0.464, 0.701, 1.402,  0,0
		//61800.0, 0.0004, 44.236, 233.795, 0.006, 99.403, 776.5824144, 0.464, 0.701, 1.402,  0,0
	}, 
	//--  Desdemona
	{
		"Uranus",
		"Desdemona",	{"Desdemona", "Desdemona"},		"",
		32.0, 32.0, 32.0,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		62700.0, 0.0001, 183.285, 184.627, 180.113, 306.089, 760.0555393, 0.474, 0.737, 1.474,  0,0
		//62700.0, 0.0001, 183.285, 184.627, 0.113, 306.089, 760.0555393, 0.474, 0.737, 1.474,  0,0
	}, 
	//--  Juliet
	{
		"Uranus",
		"Juliet",		{"Juliet", "Juliet"},		"",
		46.8, 46.8, 46.8,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		64400.0, 0.0007, 223.819, 244.696, 180.065, 200.155, 730.1261349, 0.493, 0.809, 1.619,  0,0
		//64400.0, 0.0007, 223.819, 244.696, 0.065, 200.155, 730.1261349, 0.493, 0.809, 1.619,  0,0
	}, 
	//--  Portia
	{
		"Uranus",
		"Portia",		{"Portia", "Portia"},		"",
		67.6, 67.6, 67.6,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		66100.0, 0.0001, 222.433, 218.312, 180.059, 260.067, 701.4864814, 0.513, 0.888, 1.777,  0,0
		//66100.0, 0.0001, 222.433, 218.312, 0.059, 260.067, 701.4864814, 0.513, 0.888, 1.777,  0,0
	}, 
	//--  Rosalind
	{
		"Uranus",
		"Rosalind",		{"Rosalind", "Rosalind"},		"",
		36.0, 36.0, 36.0,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		69900.0, 0.0001, 140.477, 136.181, 180.279, 12.847, 644.6304183, 0.558, 1.081, 2.163,  0,0
		//69900.0, 0.0001, 140.477, 136.181, 0.279, 12.847, 644.6304183, 0.558, 1.081, 2.163,  0,0
	}, 
	//--  Belinda
	{
		"Uranus",
		"Belinda",		{"Belinda", "Belinda"},		"",
		40.3, 40.3, 40.3,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		75300.0, 0.0001, 42.406, 357.224, 180.031, 279.337, 577.3602885, 0.624, 1.397, 2.796,  0,0
		//75300.0, 0.0001, 42.406, 357.224, 0.031, 279.337, 577.3602885, 0.624, 1.397, 2.796,  0,0
	}, 
	//--  Puck
	{
		"Uranus",
		"Puck",			{"Puck", "Puck"},			"",
		81.0, 81.0, 81.0,
		SAT_ORBIT_EQUATORIAL,
		2446450.0,
		86000.0, 0.0001, 177.094, 245.796, 180.319, 268.734, 472.5445878, 0.762, 2.224, 4.448,  0,0
		//86000.0, 0.0001, 177.094, 245.796, 0.319, 268.734, 472.5445878, 0.762, 2.224, 4.448,  0,0
	}, 
	//--  Perdita
	{
		"Uranus",
		"Perdita",		{"Perdita", "Perdita"},		"",
		15.0, 15.0, 15.0,
		SAT_ORBIT_EQUATORIAL,
		2453243.0,
		76417.0, 0.0116, 253.925, 192.405, 180.470, 309.376, 564.2469590, 0.638, 1.479, 2.958,  0,0
		//76417.0, 0.0116, 253.925, 192.405, 0.470, 309.376, 564.2469590, 0.638, 1.479, 2.958,  0,0
	}, 
	//--  Mab
	{
		"Uranus",
		"Mab",			{"Mab", "Mab"},				"",
		12.0, 12.0, 12.0,
		SAT_ORBIT_EQUATORIAL,
		2453243.0,
		97736.0, 0.0025, 249.565, 273.769, 180.134, 350.737, 390.0501070, 0.923, 3.502, 7.004,  0,0
		//97736.0, 0.0025, 249.565, 273.769, 0.134, 350.737, 390.0501070, 0.923, 3.502, 7.004,  0,0
	}, 
	//--  Cupid
	{
		"Uranus",
		"Cupid",		{"Cupid", "Cupid"},				"",
		9.0, 9.0, 9.0,
		SAT_ORBIT_EQUATORIAL,
		2453243.0,
		74392.0, 0.0013, 247.608, 163.830, 180.099, 182.793, 587.4436490, 0.613, 1.346, 2.693,  0,0
		//74392.0, 0.0013, 247.608, 163.830, 0.099, 182.793, 587.4436490, 0.613, 1.346, 2.693,  0,0
	}, 
	//--  Caliban
	{
		"Uranus",
		"Caliban",		{"Caliban", "Caliban"},				"",
		49.0, 49.0, 49.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		7231000.0, 0.1587, 342.817, 325.188, 140.881, 163.845, 0.6209747, 579.73, 10186.54, 6539.92, 277.436, 64.637 
	}, 
	//--  Sycorax
	{
		"Uranus",
		"Sycorax",		{"Sycorax", "Sycorax"},				"",
		95.0, 95.0, 95.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		12179000.0, 0.5224, 21.291, 8.788, 159.404, 261.915, 0.2794387, 1288.30, 1393.19, 1862.89, 272.154, 66.466 
	}, 
	//--  Prospero
	{
		"Uranus",
		"Prospero",		{"Prospero", "Prospero"},			"",
		15.0, 15.0, 15.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		16256000.0, 0.4448, 175.554, 187.893, 151.966, 318.599, 0.1819751, 1978.29, 1155.14, 1370.49, 271.470, 66.399
	}, 
	//--  Setebos
	{
		"Uranus",
		"Setebos",		{"Setebos", "Setebos"},				"",
		15.0, 15.0, 15.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		17418000.0, 0.5914, 1.539, 93.328, 158.202, 249.456, 0.1617822, 2225.21, 824.05, 1044.44, 272.151, 66.317 
	}, 
	//--  Stephano
	{
		"Uranus",
		"Stephano",		{"Stephano", "Stephano"},			"",
		10.0, 10.0, 10.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		8004000.0, 0.2292, 19.024, 65.156, 144.113, 188.561, 0.5314740, 677.36, 5379.48, 5225.09, 272.003, 66.170 
	}, 
	//--  Trinculo
	{
		"Uranus",
		"Trinculo",		{"Trinculo", "Trinculo"},			"",
		5.0, 5.0, 5.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		8504000.0, 0.2200, 159.773, 255.448, 167.050, 192.806, 0.4804851, 749.24, 2586.68, 4257.88, 271.873, 66.318 
	}, 
	//--  S/2001_U2
	{
		"Uranus",
		"S/2001 U2",		{"S/2001 U2", "S/2001 U2"},			"",
		6.0, 6.0, 6.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		20901000.0, 0.3682, 159.568, 234.514, 169.840, 216.431, 0.1246879, 2887.21, 746.92, 996.22, 271.934, 66.322 
	}, 
	//--  S/2001_U3
	{
		"Uranus",
		"S/2001 U3",		{"S/2001 U3", "S/2001 U3"},			"",
		6.0, 6.0, 6.0,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		4276000.0, 0.1459, 124.720, 90.868, 145.220, 93.135, 1.3505648, 266.56, 16369.87, 14734.26, 276.911, 64.927 
	}, 
	//--  S/2003_U3
	{
		"Uranus",
		"S/2003 U3",		{"S/2003 U3", "S/2003 U3"},			"",
		5.5, 5.5, 5.5,
		SAT_ORBIT_LAPLACE,
		2453200.5,
		14345000.0, 0.6608, 89.354, 322.440, 56.630, 3.535, 0.2133950, 1687.01, 1599805.74, 990.74, 272.570, 65.736 
	}, 




//==================
//   Neptune (13)
//==================
	//--  Triton
	{
		"Neptune",
		"Triton",		{"Triton", "gg"},			"Triton.jpg",
		1352.6, 1352.6, 1352.6,
		SAT_ORBIT_LAPLACE,
		2447763.5,
		354800.0, 0.0000, 344.046, 264.775, 156.834, 172.431, 61.2601284, 5.877,  397.516, 688.126, 299.358, 43.455
	},
	//--  Nereid
	{
		"Neptune",
		"Nereid",		{"Nereid", "lCh"},			"",
		170.0, 170.0, 170.0,
		SAT_ORBIT_LAPLACE,
		2447763.5,
		5513400.0, 0.7512, 280.830, 359.341,   7.232, 334.762,  0.9996241, 360.14, 7787.26, 9191.62, 270.113, 69.155
	}, 
	//--  Naiad
	{
		"Neptune",
		"Naiad",		{"Naiad", "Naiad"},			"",
		33.0, 33.0, 33.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		48227.0, 0.0004, 31.733, 339.933, 4.746, 56.438, 1222.8435785, 0.294, 0.289, 0.575, 299.271, 42.942 
	}, 
	//--  Thalassa
	{
		"Neptune",
		"Thalassa",		{"Thalassa", "Thalassa"},			"",
		41.0, 41.0, 41.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		50075.0, 0.0002, 323.125, 186.362, 0.209, 98.094, 1155.7559767, 0.311, 0.327, 0.654, 299.271, 42.941 
	}, 
	//--  Despina
	{
		"Neptune",
		"Despina",		{"Despina", "Despina"},				"",
		75.0, 75.0, 75.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		52526.0, 0.0002, 293.365, 0.253, 0.064, 159.496, 1075.7330611, 0.335, 0.386, 0.773, 299.271, 42.939 
	}, 
	//--  Galatea
	{
		"Neptune",
		"Galatea",		{"Galatea", "Galatea"},				"",
		88.0, 88.0, 88.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		61953.0, 0.0000, 27.468, 261.313, 0.062, 125.707, 839.6612879, 0.429, 0.689, 1.380, 299.269, 42.927 
	}, 
	//--  Larissa
	{
		"Neptune",
		"Larissa",		{"Larissa", "Larissa"},				"",
		97.0, 97.0, 97.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		73548.0, 0.0014, 138.073, 37.004, 0.205, 17.588, 649.0540761, 0.555, 1.256, 2.513, 299.264, 42.899 
	}, 
	//--  Proteus
	{
		"Neptune",
		"Proteus",		{"Proteus", "Proteus"},				"",
		210.0, 210.0, 210.0,
		SAT_ORBIT_LAPLACE,
		2447757.0,
		117647.0, 0.0005, 301.706, 117.050, 0.026, 162.690, 320.7656260, 1.122, 6.391, 12.787, 299.175, 42.404 
	}, 
	//--  S/2002_N1
	{
		"Neptune",
		"S/2002 N1",	{"S/2002 N1", "S/2002 N1"},			"",
		31.0, 31.0, 31.0,
		SAT_ORBIT_ECLIPTIC,
		2452800.5,
		15728000.0, 0.5711, 159.729, 96.399, 134.101, 202.989, 0.1915188, 1879.71, 5373.24, 5089.27,  0,0
	}, 
	//--  S/2002_N2
	{
		"Neptune",
		"S/2002 N2",	{"S/2002 N2", "S/2002 N2"},			"",
		22.0, 22.0, 22.0,
		SAT_ORBIT_ECLIPTIC,
		2452800.5,
		22422000.0, 0.2931, 79.334, 207.083, 48.511, 55.532, 0.1235386, 2914.07, 68144.33, 4729.39,  0,0
	}, 
	//--  S/2002_N3
	{
		"Neptune",
		"S/2002 N3",	{"S/2002 N3", "S/2002 N3"},			"",
		21.0, 21.0, 21.0,
		SAT_ORBIT_ECLIPTIC,
		2452800.5,
		23571000.0, 0.4237, 142.395, 328.589, 34.741, 60.693, 0.1136419, 3167.85, 2264.02, 3176.12,  0,0
	}, 
	//--  S/2003_N1
	{
		"Neptune",
		"S/2003 N1",	{"S/2003 N1", "S/2003 N1"},			"",
		30.0, 30.0, 30.0,
		SAT_ORBIT_ECLIPTIC,
		2452800.5,
		46695000.0, 0.4499, 145.905, 206.165, 137.391, 300.968, 0.0394914, 9115.91, 1485.62, 1332.35,  0,0
	},
	//--  S/2002_N4
	{
		"Neptune",
		"S/2002 N4",	{"S/2002 N4", "S/2002 N4"},			"",
		20.0, 20.0, 20.0,
		SAT_ORBIT_ECLIPTIC,
		2452800.5,
		48387000.0, 0.4945, 89.330, 269.829, 132.585, 49.985, 0.0384042, 9373.99, 588583.45, 1053.21,  0,0
	},


//===============
//   Pluto (5)
//===============
	//--  Charon
	{
		"Pluto",
		"Charon",		{"Charon", "J"},			"charon.jpg",
		603.6, 603.6, 603.6,
		SAT_ORBIT_ICRF,
		2451544.5,
		19596.0, 0.00005,  189.9, 86.1,   0.0,  0.0, 56.3625,   6.3872, 0.000,   0.000, 133.03, -6.23
	},
	//--  Styx
	{
		"Pluto",
		"Styx", {"Styx", "XeBNX"}, "",
		9.0, 9.0, 9.0,
		SAT_ORBIT_ICRF,
		2451544.5,
		42413.0, 0.00001, 17.8, 162.7, 0.0, 0.0, 17.8556, 20.1617, 0.0, 0.0, 133.03, -6.23
	},
	//--  Nix
	{ 
		"Pluto",
		"Nix",			{"Nix",    "jNX"},				"",
		17.5, 17.5, 17.5,
		SAT_ORBIT_ICRF,
		2451544.5,
		48690.0, 0.0, 0.0, 85.0,   0.0, 0.0, 14.4841,   24.8548,  0.0, 0.0, 133.03, -6.23
	},
	//--  Kerberos
	{
		"Pluto",
		"Kerberos", {"Kerberos", "PxX"}, "",
		14.5, 14.5, 14.5,
		SAT_ORBIT_ICRF,
		2451544.5,
		57750.0, 0.0, 46.7, 261.9, 0.4, 313.3, 11.1913, 32.1679, 0.0, 0.0, 133.03, -6.23
	},
	//--  Hydra
	{
		"Pluto",
		"Hydra", {"Hydra", "qh"}, "",
		22.5, 22.5, 22.5,
		SAT_ORBIT_ICRF,
		2451544.5,
		64721.0, 0.00554, 135.3, 330.4, 0.3, 122.7, 9.4236, 38.2021, 0.0, 0.0, 133.03, -6.23
	}
};





const int SatellitesNum = sizeof(sat_data)/sizeof(sat_data[0]);


//---  Position and orientation
vector3d  vSatellitePos[SatellitesNum];
static matrix3d  vSatelliteOrbitMatrix[SatellitesNum];	



//---  Planet ID
static int satellite_planet_index[SatellitesNum];


//---  OpenGL texture
static GLuint	texSatellites[SatellitesNum];





//---  Number of satellites
int
get_satellites_num()
{
	return SatellitesNum;
}



//---  Name of satellite
bilingual
get_satellite_name(int idx)
{
	return  sat_data[idx].name;
}


//---  Planet ID

int
get_satellite_planet_index(int idx)
{
	return  satellite_planet_index[idx];
}



//---  Size
void
get_satellite_size(int mode, int idx, bool bRealSize, double& Rx, double& Ry, double& Rz)
{
	Rx = sat_data[idx].Rx;
	Ry = sat_data[idx].Ry;
	Rz = sat_data[idx].Rz;

	if (idx==SAT_MOON && !bRealSize) {
		double  fac;
		if (mode == MODE_3D)		fac = get_zoom_rate().zmhPlanet;
		else						fac = get_zoom_rate().zmpSunMoon * get_zoom_rate().zmhMoonOrb;
		Rx *= fac;
		Ry *= fac;
		Rz *= fac;
	}
}


//------------
//  Textures
//------------
void
load_satellites_textures_sub(int shrink_rate)
{
	for (int i=0; i<SatellitesNum; i++) {
		const satellite_data&  sd = sat_data[i];
		if (sd.texture_name[0] != '\0') {
			texSatellites[i] = LoadTexture( sd.texture_name, shrink_rate, false );
		} else {
			texSatellites[i] = -1;
		}
	}
}


int
get_satellite_texture_index(int idx)
{
	return  texSatellites[idx];
}






//--------------------------------------
//  qW物Wւ̕ϊs߂
//--------------------------------------
//******** ̕ϊs͖  ***************
matrix3d
calc_satellite_orbit_matrix(int idx, const double& t)
{
	const satellite_data &sd = sat_data[idx];

	if (sd.orbit_type == SAT_ORBIT_MOON) {
		return  matrix3d(1,0,0, 0,1,0, 0,0,1);
	}


	double domg, dOmg;
	double dt, omg, node;
	domg = (sd.Pw != 0.0)     ?  360.0 / sd.Pw / 365.25     :  0.0;
	dOmg = (sd.Pnode != 0.0)  ?  360.0 / sd.Pnode / 365.25  :  0.0;
	dt = t - sd.epoch;
	omg  = sd.omg  + domg*dt;
	node = sd.node + dOmg*dt;

	switch(sd.orbit_type) {
		case SAT_ORBIT_LAPLACE:		// vXʂ
			return  M_R2E * Rzxz3deg(90+sd.RA, 90-sd.DEC, 0.0) * Rzxz3deg(node, sd.i, omg);
		case SAT_ORBIT_ICRF:		// ICRF
			return  M_R2E * Rzxz3deg(90 + sd.RA, 90 - sd.DEC, 0.0) * Rzxz3deg(node, sd.i, omg);
		case SAT_ORBIT_EQUATORIAL:	// fԓʂ
			return  get_planet_pl_to_ec_matrix0( satellite_planet_index[idx] ) * Rzxz3deg(node, sd.i, omg);
		case SAT_ORBIT_ECLIPTIC:	// ʂ
		default:
			return  Rzxz3deg(node, sd.i, omg);
	}
}


//---------------------------------
//  q̈ʒu߂(SW)
//  x t_Axy-ʂ
//---------------------------------
vector3d
calc_satellites_position(int idx, const double& t)
{
	const int pidx = satellite_planet_index[idx];

	//--  Moon  --
	if (idx == SAT_MOON) {
		const double fac_M = get_zoom_rate().zmhMoonOrb;
		return  get_planet_position(pidx) + fac_M * double(_1km_pc) * calc_lunar_pos(t);
	}

	//--  Other satellites  --
	const satellite_data &sd = sat_data[idx];
	vector3d  ro, rL, rICRF, rE;

	// omg, node  precession
	double domg, dOmg, n;
	domg = (sd.Pw != 0.0)     ?  360.0 / sd.Pw / 365.25     :  0.0;
	dOmg = (sd.Pnode != 0.0)  ?  360.0 / sd.Pnode / 365.25  :  0.0;
	n    = sd.n - domg - dOmg;

	// Oʏ̈ʒu
	ro = calc_orbital_pos(sd.a*_1km_AU, sd.e, sd.M0, n, sd.epoch, t);
	rE = vSatelliteOrbitMatrix[idx] * ro;
	
	return  get_planet_position( pidx ) + double(_1AU_pc) * rE;
}

vector3d
calc_lunar_real_position(const double& t)
{
	return  get_planet_position(PLNT_EARTH) + double(_1km_pc) * calc_lunar_pos(t);
}

void
update_satellites_position(const double& t)
{
	for (int i=0; i<SatellitesNum; i++) {
		vSatelliteOrbitMatrix[i] = calc_satellite_orbit_matrix(i, t);
		vSatellitePos[i] = calc_satellites_position(i, t);
	}
}

matrix3d
get_satellite_orbit_matrix(int idx)
{
	return  vSatelliteOrbitMatrix[idx];
}



vector3d
get_satellite_position(int idx)
{
	return  vSatellitePos[idx];
}

void
set_satellite_position(int idx, const vector3d& pos)
{
	vSatellitePos[idx] = pos;
}


vector3d
get_satellite_position_relative_to_planet(int idx)
{
	return  vSatellitePos[idx] - get_planet_position( get_satellite_planet_index(idx) );
}


vector3d
calc_satellite_orbit_pos(int idx, const double& t, float phi)
{
	const int pidx = satellite_planet_index[idx];

	//---  Moon  ---
	if (idx == SAT_MOON)  {
		const double fac_M = get_zoom_rate().zmhMoonOrb;
		return  (fac_M * double(_1km_pc)) * calc_lunar_pos(t - 27.3*((phi-pi)/(2*pi)) )  + get_planet_position( pidx );
	}

	//---  Other satellites  ---
	const satellite_data &sd = sat_data[idx];

	vector3d r0;
	r0 = get_planet_position(pidx);

	return  get_satellite_orbit_matrix(idx) * calc_orbital_position(sd.a, sd.e, phi) * _1km_pc + r0;
}







//------------
//  Register
//------------
void
register_object_satellites()
{
	mtk_object  obj;
	for (int i=0; i<SatellitesNum; i++) {	//******//
		const satellite_data&  sd = sat_data[i];
		
		const char* key = sd.key;

		//-- init planet index
		int planet_idx = get_object( sd.planet_key ).get_index() ;
		satellite_planet_index[i] = planet_idx;


		//--  register satellites
		obj.init(OBJ_TYPE_SATELLITE, i, 0.0f, true);
		int obj_idx = register_object(obj, key);

		//--  register labels
		bilingual  name = get_satellite_name(i);
		double Rx, Ry, Rz;
		get_satellite_size(MODE_3D, i, true, Rx,Ry,Rz);
		float R = 1.4 * _1km_pc * Rx;
		float thc = 8 * D2R;

		char str[256];
		sprintf(str, "%sLabel", key);
		add_label( name.text_J, name.text_E, obj_idx, MTK_COLOR_NAME_SATELLITE, 1.0f, get_satellites_name_size(), R, thc, true, str );
	}
}
